"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
require("isomorphic-fetch");
var frisbee_1 = require("frisbee");
var V3;
(function (V3) {
    'use strict';
    var ACCESS_TOKEN = 'qjP1UJavDqPSkDSBxz6r';
    var api = new frisbee_1.default({
        baseURI: 'https://gitlab.com/api/v3',
        headers: {
            'PRIVATE-TOKEN': ACCESS_TOKEN
        }
    });
    function getProjects() {
        return new Promise(function (resolve, reject) {
            api.get('/projects?owned=true').then(function (result) {
                resolve(result.body);
            });
        });
    }
    V3.getProjects = getProjects;
    function getProject(name) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var projects, matchingProjects;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, getProjects()];
                    case 1:
                        projects = _a.sent();
                        matchingProjects = projects.filter(function (project) { return (name === project.name); });
                        if (matchingProjects.length > 0) {
                            resolve(matchingProjects[0]);
                        }
                        else {
                            reject(undefined);
                        }
                        return [2 /*return*/];
                }
            });
        }); });
    }
    V3.getProject = getProject;
    function getActiveMilestones(projectId) {
        return new Promise(function (resolve, reject) {
            api.get("/projects/" + projectId + "/milestones?state=active").then(function (result) {
                resolve(result.body.map(function (item) {
                    var mileStone = {
                        id: '',
                        title: '',
                        description: '',
                        dueDate: undefined,
                        startDate: undefined
                    };
                    mileStone.id = item.id;
                    mileStone.title = item.title;
                    mileStone.description = item.description;
                    mileStone.dueDate = new Date(item.due_date);
                    mileStone.startDate = new Date(item.start_date);
                    return mileStone;
                }));
            });
        });
    }
    V3.getActiveMilestones = getActiveMilestones;
    function getCurrentMilestone(projectId, date) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var activeMilestones, currentMilestone;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, getActiveMilestones(projectId)];
                    case 1:
                        activeMilestones = _a.sent();
                        currentMilestone = activeMilestones.reduce(function (aggregate, milestone) {
                            if (milestone.dueDate >= date) {
                                if (!aggregate || aggregate.dueDate > milestone.dueDate) {
                                    aggregate = milestone;
                                }
                            }
                            return aggregate;
                        }, undefined);
                        currentMilestone ? resolve(currentMilestone) : reject(undefined);
                        return [2 /*return*/];
                }
            });
        }); });
    }
    V3.getCurrentMilestone = getCurrentMilestone;
    function getMilestoneIssues(projectId, mileStoneId) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                api.get("/projects/" + projectId + "/milestones/" + mileStoneId + "/issues").then(function (result) {
                    resolve(result.body);
                });
                return [2 /*return*/];
            });
        }); });
    }
    V3.getMilestoneIssues = getMilestoneIssues;
    function getTimeStatus(projectId, issueId) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var notes, progressRegex, progress;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, getComments(projectId, issueId)];
                    case 1:
                        notes = _a.sent();
                        progressRegex = /#progress( *)(:?)( *)\d*%/g;
                        progress = notes.filter(function (note) { return note.body && note.body.match(progressRegex); })
                            .sort(function (a, b) { return a.createdAt.getTime() - b.createdAt.getTime(); })
                            .reduce(function (accumulate, note) {
                            return accumulate.concat(note.body.match(progressRegex));
                        }, [])
                            .reduce(function (accumulate, individualProgress) {
                            console.log(individualProgress);
                            return accumulate.concat(individualProgress.match(/\d*%/g));
                        }, []);
                        console.log(progress);
                        resolve(progress);
                        return [2 /*return*/];
                }
            });
        }); });
    }
    V3.getTimeStatus = getTimeStatus;
    function getComments(projectId, issueId) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                api.get("/projects/" + projectId + "/issues/" + issueId + "/notes").then(function (result) {
                    resolve(result.body.map(function (note) {
                        var newNote = Object.assign({}, note);
                        newNote.createdAt = new Date(note.created_at);
                        return newNote;
                    }));
                });
                return [2 /*return*/];
            });
        }); });
    }
    V3.getComments = getComments;
})(V3 = exports.V3 || (exports.V3 = {}));
//# sourceMappingURL=version-3.js.map