"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("./service");
var common_1 = require("../common");
var urlencode = require('urlencode');
var Labels;
(function (Labels) {
    function getAll(projectId) {
        return new Promise(function (resolve, reject) {
            service_1.service.get("/projects/" + projectId + "/labels")
                .then(function (result) { return resolve(result.body); })
                .catch(function (error) { return reject(error); });
        });
    }
    Labels.getAll = getAll;
    function create(projectId, name, color, description) {
        var params = [];
        params.push(common_1.REST.QueryParam.createQuery('name', name));
        params.push(common_1.REST.QueryParam.createQuery('color', urlencode(color)));
        params.push(common_1.REST.QueryParam.createQuery('description', description));
        console.log("/projects/" + projectId + "/labels?", params, common_1.REST.QueryParam.join(params));
        return new Promise(function (resolve, reject) {
            service_1.service.post("/projects/" + projectId + "/labels?" + common_1.REST.QueryParam.join(params))
                .then(function (result) { return resolve(result.body); })
                .catch(function (error) { return reject(error); });
        });
    }
    Labels.create = create;
})(Labels = exports.Labels || (exports.Labels = {}));
//# sourceMappingURL=labels.js.map