"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("./service");
var models_1 = require("../models");
var common_1 = require("../common");
var Projects;
(function (Projects) {
    function getAll(visibity, owned, membership, sort, orderby, search) {
        if (visibity === void 0) { visibity = models_1.Visibility.PRIVATE; }
        if (owned === void 0) { owned = true; }
        if (membership === void 0) { membership = true; }
        if (sort === void 0) { sort = models_1.SortOrder.ASCENDING; }
        if (orderby === void 0) { orderby = models_1.Orderby.CREATED_AT; }
        var params = [];
        params.push(common_1.REST.QueryParam.createQuery('visibility', visibity));
        params.push(common_1.REST.QueryParam.createQuery('owned', owned.toString()));
        params.push(common_1.REST.QueryParam.createQuery('membership', membership.toString()));
        params.push(common_1.REST.QueryParam.createQuery('sort', sort));
        params.push(common_1.REST.QueryParam.createQuery('order_by', orderby));
        params.push(common_1.REST.QueryParam.createQuery('search', search));
        return new Promise(function (resolve, reject) {
            service_1.service.get("/projects?" + common_1.REST.QueryParam.join(params))
                .then(function (result) { return resolve(result.body); })
                .catch(function (error) { return reject(error); });
        });
    }
    Projects.getAll = getAll;
    function getOne(id) {
        return new Promise(function (resolve, reject) {
            service_1.service.get("/projects/" + id)
                .then(function (result) { return resolve(result.body); })
                .catch(function (error) { return reject(error); });
        });
    }
    Projects.getOne = getOne;
})(Projects = exports.Projects || (exports.Projects = {}));
//# sourceMappingURL=projects.js.map